{{
*****************************************
* Memsic 2125 autopilot    v1.0         *
* Author: Forrest Bourke                *
* Copyright (c) 2009 Forizzle           *
*****************************************


History:

Version 1.0 - original release
Version 1.1 - modified code to return RAW x and y values

}}

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
 ' _stack = ($3000 + $3000 + 100) >> 2                   'accommodate display memory and stack

  paramcount = 14


VAR

  long  clk_scale         'To ajust for the speed of the clock
  word deg                'The degrees of tilt from the accelerometer
  long accelstack[10]     'The stack for updating the accelerometer
  long pilotstack[10]     'The stack for deciding which way to control the plane
  long servostack[10]     'The stack for running the servos.
  long size               'How much the accelerometer is off center
  long elevator           'How to move the elevator (negative is down)
  long rud                'How to move the rudder   (negative is left)


OBJ
  acc   : "memsic2125"
  servo  : "Servo"
  term : "tv_terminal"

PUB start | raw, mg, temp
  'Get everything ready.
  LEDson
  !outa[16]
  turnonandlevel
  servo.start
  waitcnt(500000 + cnt)
  !outa[16]
   waitcnt(5_000_000 + cnt)
  !outa[16]
  waitcnt(500000 + cnt)
  !outa[16]
  '!outa[23]

  'Update the accelerometer
  cognew(updateaccel,@accelstack)
  repeat
       waitcnt(cnt + 10_000_000)
       !outa[23]

        term.dec(deg)
        term.str(string("            "))
        term.dec(size)
        term.str(string(13))
        if deg < 200
           if deg > 160
              if size > 5
                 SERVO.up
                 term.str(string("down"))
        if deg < 20
           if size > 5
              SERVO.down
              term.str(string("up"))
        if deg > 340
             if size > 5
                SERVO.down
                term.str(string("up"))








PUB TurnOnAndLevel
  acc.start(1, 2)                                       'start memsic 2125
  waitcnt(clkfreq/10 + cnt)                             'wait for things to settle
  acc.setlevel                                          'assume at startup that the memsic2125 is level
  clk_scale := clkfreq / 500_000                        'set clk_scale based on system clock
  term.start(12)                                  ' Get the TV working
  servo.start


PUB UpdateAccel | raw, mg, G_scale, temp
            G_scale := 2000/(256/3)
  repeat
          raw := acc.ro                                       'Get raw value for acceleration
          raw := raw / clk_scale                              'the magnitude, really
          size := raw / G_scale                                   'scale mg value for screen display              '
          temp := acc.theta >> 19                              'scale 32-bit value to a 13-bit value
          deg := temp*360/8192


    {180 is forward, 360/0 is backward, 270 is
    left, 90 is right. Perspective is the lable
    text is forward.}

PUB LEDsOn | i
   repeat i from 16 to 23
          dira[i]~~










